
#################################################
##  
## HARDWARE INJECTION BURSTS ARE DETECTED HERE FROM ACTUAL S5 DATA,
## PLOTTED AND A LIST GIVEN WITH ASSO'D FREQUENCIES, TIMES AND SNRs.
##  
##
#################################################


import numpy as np
import matplotlib.pyplot as plt
import matplotlib.mlab as mlab
import math
import scipy.io as io
import scipy.signal as sig
import readligo as rl
plt.ion()

samprate  = 4096
nyquist = samprate / 2.

sstep=1.0/samprate

ds = sstep


####################################################################
####################################################################


####    NOW LET'S REALLY START TRYING TO DETECT BURSTS IN DATA


#####################################################################
#####################################################################

###   From Jonahs code:

# -- Set the times marking the start and stop of data downloaded.
dstart = 843894784
dstop = dstart + 4096


#seglist = rl.getsegs(dstart, dstop, 'H1', flag='CBCHIGH_CAT1')
#seglist = rl.getsegs(dstart, dstop, 'H1', flag='DATA')

# -- Define a segment list of hardware injection times:
seglist = rl.getsegs(dstart, dstop, 'H1', flag='HW')
#print seglist

# -- As before, load the data for each segment
for (start, stop) in seglist:
    strain, meta, dq = rl.getstrain(start, stop, 'H1')
    print start, stop
    print 'HW injection data seg length:', len(strain) / samprate, 'secs'



####  ELECT HOW MANY NUMBER OF SECS OF DATA TO EVALUATE,  
####  DIVISIONS PER SECOND FOR DATA EVALUATION and SNR THRESHOLD to INDICATE
####  A BURST DETECTION:

####  THERE ARE A TOTAL OF 214 SECS OF DATA HERE AND so num_sec in the 
####  NEXT LINE CAN BE CHANGED TO THAT AMOUNT TO SEE THE ENTIRE DATA SEGMENT.
####  THIS MAY CRASH PYTHON THO AS TOO MANY GRAPHS WILL BE CREATED.

num_sec = 214

divisions_per_sec = 1.

#required_snr = 8.0

timeseries = strain[ : num_sec*samprate]

signal_time_length = len(timeseries) / samprate
print 'signal_time_length:',signal_time_length, 'secs'

##  Time Domain Part:

tisq = np.square(timeseries)
tisum = np.sum(tisq * ds)
print 'Time Domain Energy:', tisum
print 'Time Domain Power:', tisum / signal_time_length
print

##  Frequency Domain Part:

fq = (1./samprate) * np.fft.fft(timeseries)
fqsq = (1./ signal_time_length) * np.square(np.abs(fq))
fqsum = np.sum(fqsq)
print 'Frequency Domain Energy:', fqsum
print 'Frequency Domain Power:', fqsum / signal_time_length
print

##  Frequency Domain Part using rfft instead of fft (need to multiply abs(fq)^2 by 2):

rfq = (1./samprate) * np.fft.rfft(timeseries)
rfqsq = 2. * (1./ signal_time_length) * np.square(np.abs(rfq[:]))
rfqsum = np.sum(rfqsq)
print 'Real Frequency Domain Energy:', rfqsum
print 'Real Frequency Domain Power:', rfqsum / signal_time_length
print


##   mlab.psd Method

psd_timeseries = mlab.psd(timeseries[:], Fs=samprate, NFFT= int(samprate/1.), noverlap=0,
window=mlab.window_none, scale_by_freq = True )

psd_mlab = np.sum(psd_timeseries[0])
print 'PSD Frequency Domain Power:', psd_mlab
print

"""
plt.figure()
plt.plot( psd_timeseries[1][1:-1],  np.log10(psd_timeseries[0][1:-1]))
plt.xlabel('Frequency')
plt.ylabel('Log10 Power')
plt.title('Power Spectral Density (PSD) of whole timeseries from mlab.psd')
plt.show()
"""


#################################################################
###   mlab.specgram Method -- MOST IMPORTANT SECTION
#################################################################


###   First sec of mlab.specgram:

spec_power_500, freqs, bins = mlab.specgram(timeseries[:samprate], Fs=samprate, NFFT=samprate/1., 
noverlap =0, window=mlab.window_none, scale_by_freq = True)
"""
plt.figure()
freq = np.arange(nyquist + 1)
plt.plot(freq,  np.log10(np.transpose(spec_power_500)[0]))
plt.xlabel('Frequency')
plt.ylabel('Log10 Power')
plt.title('Power Spectral Density (PSD) of first sec from mlab.specgram')
plt.show()
"""
trans_avg =  1./len(np.transpose(spec_power_500)) * (np.transpose(spec_power_500))
specgram_mlab = np.sum(trans_avg)
print 'First Second Specgram Frequency Domain Power:', specgram_mlab
print


###############################################
###  Now the ENTIRE timeseries evaluated with mlab.specgram:
###############################################



NFFT_factor = divisions_per_sec
noverlap_factor = NFFT_factor * 2.
window = np.blackman(samprate/NFFT_factor)

spec_power_500, freqs, bins = mlab.specgram(timeseries[:], Fs=samprate, NFFT=int(samprate/NFFT_factor),
noverlap=int(samprate/noverlap_factor), window=window, scale_by_freq = True)


###  Normalize the power at each frequency and at each time to the median power 
###  of that same frequency for the entire time:

#  Note: n will be in range [0:205]:

for n in range(spec_power_500.shape[0]):
    spec_power_500[n] = spec_power_500[n] / np.median(spec_power_500[n])
        
    
###  PLOT SPECGRAM:

###  This bit of code causes specgram to fill in to its edges:
zzz = np.array([signal_time_length])
bins = np.concatenate((bins, zzz))
bins[0] = 0.


plt.figure()
ax = plt.subplot(111)
ax.pcolormesh(bins, freqs, np.log10(spec_power_500), cmap='Blues', linewidth = 4)
plt.xlabel('Time')
plt.ylabel('Frequency')
plt.title('mlab.specgram Power Magnitude')
plt.show()



############################################

###  Next challenge is to write code which evaluates a PSD at each fraction of a sec and decides based on peak shape
###  if a burst is there or not at that moment and record the presence/absence of a signal and which specgram_column 
###  it's located in, what it's dominant freq is and what the signal max and snr are.  
###  This is now being used on a length of S5 data.

#############################################

specgram_column = np.transpose(spec_power_500)


###  WE MUST GENERATE A TRUTH TEST FOR MOMENTARY PSD PEAKS TO DETERMINE IF THEY HAVE SUFFICIENT 
###  FREQUENCY BREADTH TO LIKELY REPRESENT BURSTS OR IF THEY ARE SIMPLY RANDOM NARROW FREQUENCY SPIKES.


b = []
c = []
d = []
e = []              
bbbb = []        
aaaa = []
        
for i in range(len(specgram_column)):
    bbbb = []
    maximum = np.max(specgram_column[i])
    print 'specgram_column', i, 'maximum:',maximum
    rms = np.sqrt(np.mean(np.square(specgram_column[i])))
    snr = maximum / rms
    
    index_for_max_specgram_columni = np.where(specgram_column[i]==max(specgram_column[i]))
    print index_for_max_specgram_columni
    specgram_columni_max_index = int(index_for_max_specgram_columni[0])
    print 'specgram_columni_max_index:', specgram_columni_max_index
    
    frequency = specgram_columni_max_index * divisions_per_sec
    print 'frequency:', frequency
                 
    ###   Now set up a test to insure a significant peak width
    ###   such that freqs bins at locations +4 or -4 from max are at least 0.5 * max.
                                            
    for jjj in range(1,3):
        if specgram_column[i][specgram_columni_max_index - jjj] >=  .5 * specgram_column[i][specgram_columni_max_index]  and  specgram_column[i][specgram_columni_max_index + jjj] >=  0.5 * specgram_column[i][specgram_columni_max_index]:
            bbbb.append(True)
        else:
            bbbb.append(False)
    print 'bbbb:', bbbb

    true_comparison = [True] * len(bbbb)  
    truth_test = []   
    
    if bbbb == true_comparison:    
        truth_test.append(True)
    else:
        truth_test.append(False)
    print 'truth_test:',  truth_test
    print


    ################    END TRUTH TEST
    

    if truth_test[0] == True:     
        b.append(i)
        c.append(snr)
        d.append(specgram_columni_max_index)
        e.append(frequency)
        print 'specgram_column', i, ':', 'CONTAINS A BURST SIGNAL', 'with SNR =', snr
        print
       
print        
print 'Burst Detected at Time:', np.array(b) / noverlap_factor,'sec' 
print 'Burst Signal Detected in specgram_column:', b 
print 'at Index:',d
print 'with a Dominant Frequency of:',e, 'Hz'
c = np.round(np.array(c),2)
print 'with SNR of:',c 
print


############################################################
####      
####    NOW ITERATE FOR EACH "BURST" INDEXED ELEMENT:
############################################################


burst = b

for j in range(len(burst)):

###   Plot PSD for each moment in time (column in spectrogram) containing a burst:

    specgram_column = np.transpose(spec_power_500)
    plt.figure()
    plt.plot( freqs,  np.log10(specgram_column[burst[j]]))
    plt.xlabel('Frequency')
    plt.ylabel('Log10 Power')
    plt.title("PSD of specgram_column[{}],  from mlab.specgram".format(burst[j]))
    plt.show()
    
    """
    plt.figure()
    plt.plot( freqs,  specgram_column[burst[j]])
    plt.xlabel('Frequency')
    plt.ylabel('Power')
    #plt.title('PSD of specgram_column[burst[j]], from mlab.specgram')
    plt.title("PSD of specgram_column[{}],  from mlab.specgram".format(burst[j]))
    plt.show()
    """

###   Calculate various values for each burst:

    print 'specgram_column[{}] median:'.format(burst[j]), np.median(specgram_column[burst[j]])
    print 'specgram_column[{}] mean:'.format(burst[j]), np.mean(specgram_column[burst[j]])
    print 'specgram_column[{}] std dev:'.format(burst[j]), np.std(specgram_column[burst[j]])
    print 'specgram_column[{}] maximum:'.format(burst[j]),  np.max(specgram_column[burst[j]])

    index_for_max_specgram_columnburst = np.where(specgram_column[burst[j]]==max(specgram_column[burst[j]]))
    max_of_second_index = int(index_for_max_specgram_columnburst[0])
    
    ####   Now check truth of equation:  rms^2 == mean^2 + standard deviation^2
    ####   Which is found to be true.
    # mean^2 + standard deviation^2:
    #print np.square(np.mean(specgram_column[burst[j]])) + np.square(np.std(specgram_column[burst[j]]))
    # rms^2:
    #print np.mean(np.square(specgram_column[burst[j]]))
    

    ###   Now determine snr:

    rms = np.sqrt(np.mean(np.square(specgram_column[burst[j]])))

    print 'snr_signal:', np.max(specgram_column[burst[j]])
    
    print 'snr_noise (calculated from rms):', rms

    snr = np.max(specgram_column[burst[j]]) / rms

    print


print        
print 'Burst Detected at Time:', np.array(b) / noverlap_factor,'sec' 
print 'Burst Signal Detected in specgram_column:', b 
print 'at Index:',d
print 'with a Dominant Frequency of:',e, 'Hz'
c = np.round(np.array(c),2)
print 'with SNR of:',c 
print










